#include "kraluk.h"

#define SPUSTCAS 100

static void prycodzdi ()
{
  int i;

  if(aktupixel() == zed)
    for(i=1;; i++){
      if(mappixel(mapa, panacek->x+i, panacek->y) != zed){
	posunpost(panacek, panacek->x+i, panacek->y);
	break;
      }
      if(mappixel(mapa, panacek->x-i, panacek->y) != zed){
	posunpost(panacek, panacek->x-i, panacek->y);
	break;
      }
      if(mappixel(mapa, panacek->x, panacek->y+i) != zed){
	posunpost(panacek, panacek->x, panacek->y+i);
	break;
      }
      if(mappixel(mapa, panacek->x, panacek->y-i) != zed){
	posunpost(panacek, panacek->x, panacek->y-i);
	break;
      }
    }
}

void privaz (int pocet, kq_word **slova)
{
  kq_postava *post;

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if((pocet == 0 || !slova[0]) && panacek->animace == privazan){
    popup_info("byl privazan");
    return;
  }
  if(aktupol != pol[7][3] && (aktupol != lvi || lvistav > 1)){
    if(pocet == 0 || !slova[0]) popup_info("privaz kam?");
    else popupwarning("privaz to kam?", slova[0]->nazev);
    return;
  }
  if(pocet && slova[0] == kaminek->slovo){
    if(kamen && (smpixel(bgmap, kamen->x, kamen->y) != dosahpredmet ||
		 smpixel(kamen->submap, panacek->x, panacek->y) != dosahpredmet)){
      popup_info("_too far");
      return;
    }
  }
  else{
    if(aktupixel() != dosahpredmet){
      popup_info("_too far");
      return;
    }
  }
  if(aktupol == pol[7][3] && (pocet == 0 || !slova[0])){
    popup_info("spousteni");
    lvistav = 2;
    zmenanip(panacek, privazan);
    panacek->x = 67;
    panacek->y = 64;
    panacek->tim->funkce = provaz_step;
    post_z(panacek, 0, 0, -1);
    return;
  }
  if(aktupol != lvi){
    popup_info("neni duvod");
    return;
  }
  lvistav += 4;
  if(pocet == 0 || !slova[0]){
    if(princezna->inv){
      popup_info("bobes neunese");
      lvistav -= 4;
      return;
    }
    panacek->tim->funkce = provaz_step;
    panacek->x = 97;
    panacek->y = 60;
    post_z(panacek, 0, 0, 76);
    zmenanip(panacek, privazan);
    popup_info("taha panacka");
  }
  else if(slova[0] == princezna->slovo ||
	  slova[0] == osoba || slova[0] == divka){
    if(!princezna->inv){
      popup_info("nemam princeznu");
      lvistav -= 4;
      return;
    }
    predmetnull(princezna);
    osoba->kontext--;
    divka->kontext--;
    post = vytvorpost(90, 42, NAHORU, 0, 0, 1, 0);
    zmenanip(post, nactianip(1, 0, "princezna", 1, 0, 1, 0, 1));
    post->z = 74.8;
    vytvortimer(provaz_step, pinpointer(post), 3, -1, 0, 1, 0);
    popup_info("taha princeznu");
  }
  else if(slova[0] == kaminek->slovo && kamen){
    hidesubmap(kamen->submap);
    kamen->x = 98;
    kamen->y = 57;
    post_z(kamen, 0, 0, 74.8);
    vytvortimer(provaz_step, pinpointer(kamen), 3, -1, 0, 1, 0);
    popup_info("taha kamen");
   }
  else{
    lvistav -= 4;
    popup_info("neni duvod");
  }
}

void provaz_step (kq_postava *post)
{
  if(aktupol == pol[7][3] && post->y == 100){
    kql_square(post, lvi, 97, 0, 0, 0, 0);
    divka->kontext++;
    osoba->kontext++;
    lev->kontext++;
    znak = 0;
    post->y = -35;
    post->z = 76;
    wprovaz = vytvorwidget(195, -159, 75, nactikqXPM("provaz", 1), 1, 0);
  }
  else if(lvistav < 4){
    if(aktutimer->cas == 1){
      if(post->y > 50){
	if(post == kamen){
	  kamen = NULL;
	  znictimer(aktutimer);
	}
	else{
	  panacek = ovlpost = NULL;
	}
	znicpost(post);
	vytvorwidget(180, 107, 0, nactikqXPM("dira", 1), 1, 0);
	if(!panacek) vytvorsubmap(90, 72, 5, "dira", 1, 0);
	else if(smpixel(vytvorsubmap(90, 72, 5, "dira", 1, 0), panacek->x, panacek->y)){
	  znicpost(panacek);
	  panacek = ovlpost = NULL;
	  popup_info("kamen na hlavu");
	}	  
	return;
      }
      post->y += 2;
      anip_step(post);
      zmenapost(post);
      return;
    }
    if(post){
      post->y++;
      zmenapost(post);
    }
    if(wprovaz && wprovaz->y == -74 && kamen && post == kamen){
      kamen->submap->x = 96-kamen->sm_x;
      kamen->submap->y = 75-kamen->sm_y;

      unhidesubmap(kamen->submap);

      prycodzdi();
    }
    if(wprovaz) posunwidget(wprovaz, wprovaz->x, wprovaz->y+1);
    if(aktupol == pol[7][3] && post->y == 100)
      zmentimer(aktutimer, SPUSTCAS, aktutimer->priorita);
    if(aktupol == lvi && wprovaz->y == -64){
      if(post){
	post->x = 96;
	post->y = 75;
	post->xx = post->yy = 0;
	normal_z(post, NULL, NULL);
	if(post == panacek){
	  zmenanip(post, chozeni);
	  post->smer = VPRAVO;
	  aktutimer->funkce = jdipost;
	  prycodzdi();
	}
	else znictimer(aktutimer);
      }
      else znictimer(aktutimer);
      lvistav -= 2;
    }
  }
  else{
    post->y--;
    zmenapost(post);
    if(wprovaz) posunwidget(wprovaz, wprovaz->x, wprovaz->y-1);
    if(post->y == -55){
      if(!princezna->inv && !princezna->pol &&
	 (post == panacek || post == kamen)){
	aktutimer->cas = 1;
	znicwidget(wprovaz);
	wprovaz = NULL;
	zmentimer(aktutimer, SPUSTCAS/2, aktutimer->priorita);
      }
      zmentimer(aktutimer, SPUSTCAS, aktutimer->priorita);
    }
    if(post->y == -56){
      if(aktutimer->cas == 1){
	zmentimer(aktutimer, SPUSTCAS/6, aktutimer->priorita);
	if(post == panacek){
	  zmenanip(post, padani);
	  popup_info("pada panac");
	}
	else popup_info("pada kamen");
      }
      else{
	zmentimer(aktutimer, SPUSTCAS, aktutimer->priorita);
	if(post == kamen) popup_info("vraci kamen");
	else if(post == panacek) popup_info("vraci panacka");
	else{
	  popup_info("bere princeznu");
	  znicpost(post);
	  aktutimer->parametr = pinpointer(NULL);
	}
      }
      lvistav -= 2;
    }
  }
}

void posun (int pocet, kq_word **slova)
{
  int xx, yy;

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(!kamen || (pocet && slova[0] != kaminek->slovo)){
    popup_info("neni duvod");
    return;
  }
  if(smpixel(kamen->submap, panacek->x, panacek->y) != dosahpredmet){
    popup_info("_too far");
    return;
  }

  xx = kamen->x - panacek->x;
  yy = kamen->y - panacek->y;

  if(abs(xx) > abs(yy)){
    if(xx > 0){
      xx = 5;
      panacek->smer = VPRAVO;
    }
    else{
      xx = -5;
      panacek->smer = VLEVO;
    }
    yy = 0;
  }
  else{
    xx = 0;
    if(yy > 0){
      yy = 5;
      panacek->smer = DOLU;
    }
    else{
      yy = -5;
      panacek->smer = NAHORU;
    }
  }

  zmenapost(panacek);
  if(posunpost(kamen, kamen->x+xx, kamen->y+yy)) popup_info("posunul kamen");
  else popup_info("posun do zdi");
}
